unit USBUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  USBManager, StdCtrls, Grids, ColorButton, USBUnit2, ExtCtrls;

type
  TForm1 = class(TForm)
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label1: TLabel;
    Label19: TLabel;
    CButtAdd: TjanColorButton;
    CButtRem: TjanColorButton;
    Label20: TLabel;
    SG: TStringGrid;
    Edit2: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Edit14: TEdit;
    Edit15: TEdit;
    Memo3: TMemo;
    Memo4: TMemo;
    ButtonScanUSB: TButton;
    Edit3: TEdit;
    Edit16: TEdit;
    Memo1: TMemo;
    Edit1: TEdit;
    USBMan: TUSBManager;
    Button1: TButton;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure SGSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure ButtonScanUSBClick(Sender: TObject);
    procedure USBEvents1DeviceAdded(Sender: TObject);
    procedure USBEvents1DeviceRemoved(Sender: TObject);
    procedure CButtAddclick(Sender: TObject);
    procedure CButtRemclick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  SG.DefaultRowHeight := 20;
  SG.ColWidths[0] := 20;
  SG.Cells[0,0] := 'No';
  SG.ColWidths[1] := 510;
  SG.Cells[1,0] := 'Devce Path';
  SG.ColWidths[2] := 45;
  SG.Cells[2,0] := 'Vender';
  SG.ColWidths[3] := 45;
  SG.Cells[3,0] := 'Product';
  SG.ColWidths[4] := 90;
  SG.Cells[4,0] := 'Firmware Revison';
  ButtonScanUSBClick(Sender);
end;

procedure TForm1.ButtonScanUSBClick(Sender: TObject);
Var No: Byte;
    DevPath: AnsiString;
    Revison: AnsiString;
    VenderID,
    ProductID: Word;
Begin
 USBMan.FreeDeviceList;
 If USBMan.InitializeDeviceList then
  begin
   SG.RowCount := USBMan.Count + 1;
   For No := 0 to USBMan.Count do
     Begin
      USBMan.FindDevice(No, DevPath, VenderID, ProductID, Revison);
      SG.Cells[0, No + 1] := IntToStr(No);
      SG.Cells[1, No + 1] := AnsiToStr(DevPath);
      SG.Cells[2, No + 1] := IntToStr(VenderID);
      SG.Cells[3, No + 1] := IntToStr(ProductID);
      SG.Cells[4, No + 1] := Revison;
     End;
   End;
end;
procedure TForm1.SGSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
var str: String;
    By: Word;
begin
  USBMan.FindDevice(ARow - 1, Str, By, By, Str);

  Edit1.Text := AnsiToStr(USBMan.FriendlyName);
  Edit2.Text := AnsiToStr(USBMan.ClassDescr);
  Edit4.Text := AnsiToStr(USBMan.Class_);
  Edit5.Text := AnsiToStr(USBMan.ClassGUID);
  Edit6.Text := AnsiToStr(USBMan.DeviceDesc);
  Edit7.Text := AnsiToStr(USBMan.Driver);
  Edit8.Text := AnsiToStr(USBMan.LocationInfo);
  Edit9.Text := AnsiToStr(USBMan.PhysDevObjName);
  Edit10.Text := AnsiToStr(USBMan.Security);
  Edit11.Text := AnsiToStr(USBMan.Service);
  Edit12.Text := IntToStr(USBMan.UINumber);
  Edit13.Text := IntToStr(USBMan.UINumberDescFormat);
  Edit14.Text := IntToStr(USBMan.RemovalPolicyOverRide);
  Str := IntToStr(USBMan.InstallState);
  If Str[1] in['0', '3'] then Edit15.Text := Str + '    = USB Device Connected'
  else Edit15.Text := Str + '    = USB Device Not Available';
  Edit3.Text := IntToStr(USBMan.CompatibleIDs);
  Edit16.Text := IntToStr(USBMan.Capabilities);
  Memo3.Lines := USBMan.HardwareID;
  Memo1.Lines := USBMan.LowerFilters;
  Memo4.Lines := USBMan.UpperFilters;
end;

procedure TForm1.USBEvents1DeviceAdded(Sender: TObject);
begin
 CButtAdd.Color := clBlue;
end;

procedure TForm1.USBEvents1DeviceRemoved(Sender: TObject);
begin
 CButtRem.Color := clBlue;
end;

procedure TForm1.CButtAddclick(Sender: TObject);
begin
   CButtAdd.Color := clBtnFace;
end;

procedure TForm1.CButtRemclick(Sender: TObject);
begin
  CButtRem.Color := clBtnFace;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  FormAbout.Visible := True;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  If StayVisable then else FormAbout.Visible := false;
  Timer1.Enabled := False;
end;

end.
